// Copyright 2015-present Basho Technologies, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by protoc-gen-go.
// source: riak_search.proto
// DO NOT EDIT!

/*
Package riak_search is a generated protocol buffer package.

It is generated from these files:
	riak_search.proto

It has these top-level messages:
	RpbSearchDoc
	RpbSearchQueryReq
	RpbSearchQueryResp
*/
package riak_search

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import riak "github.com/basho/riak-go-client/rpb/riak"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type RpbSearchDoc struct {
	Fields           []*riak.RpbPair `protobuf:"bytes,1,rep,name=fields" json:"fields,omitempty"`
	XXX_unrecognized []byte          `json:"-"`
}

func (m *RpbSearchDoc) Reset()                    { *m = RpbSearchDoc{} }
func (m *RpbSearchDoc) String() string            { return proto.CompactTextString(m) }
func (*RpbSearchDoc) ProtoMessage()               {}
func (*RpbSearchDoc) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{0} }

func (m *RpbSearchDoc) GetFields() []*riak.RpbPair {
	if m != nil {
		return m.Fields
	}
	return nil
}

type RpbSearchQueryReq struct {
	Q                []byte   `protobuf:"bytes,1,req,name=q" json:"q,omitempty"`
	Index            []byte   `protobuf:"bytes,2,req,name=index" json:"index,omitempty"`
	Rows             *uint32  `protobuf:"varint,3,opt,name=rows" json:"rows,omitempty"`
	Start            *uint32  `protobuf:"varint,4,opt,name=start" json:"start,omitempty"`
	Sort             []byte   `protobuf:"bytes,5,opt,name=sort" json:"sort,omitempty"`
	Filter           []byte   `protobuf:"bytes,6,opt,name=filter" json:"filter,omitempty"`
	Df               []byte   `protobuf:"bytes,7,opt,name=df" json:"df,omitempty"`
	Op               []byte   `protobuf:"bytes,8,opt,name=op" json:"op,omitempty"`
	Fl               [][]byte `protobuf:"bytes,9,rep,name=fl" json:"fl,omitempty"`
	Presort          []byte   `protobuf:"bytes,10,opt,name=presort" json:"presort,omitempty"`
	XXX_unrecognized []byte   `json:"-"`
}

func (m *RpbSearchQueryReq) Reset()                    { *m = RpbSearchQueryReq{} }
func (m *RpbSearchQueryReq) String() string            { return proto.CompactTextString(m) }
func (*RpbSearchQueryReq) ProtoMessage()               {}
func (*RpbSearchQueryReq) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{1} }

func (m *RpbSearchQueryReq) GetQ() []byte {
	if m != nil {
		return m.Q
	}
	return nil
}

func (m *RpbSearchQueryReq) GetIndex() []byte {
	if m != nil {
		return m.Index
	}
	return nil
}

func (m *RpbSearchQueryReq) GetRows() uint32 {
	if m != nil && m.Rows != nil {
		return *m.Rows
	}
	return 0
}

func (m *RpbSearchQueryReq) GetStart() uint32 {
	if m != nil && m.Start != nil {
		return *m.Start
	}
	return 0
}

func (m *RpbSearchQueryReq) GetSort() []byte {
	if m != nil {
		return m.Sort
	}
	return nil
}

func (m *RpbSearchQueryReq) GetFilter() []byte {
	if m != nil {
		return m.Filter
	}
	return nil
}

func (m *RpbSearchQueryReq) GetDf() []byte {
	if m != nil {
		return m.Df
	}
	return nil
}

func (m *RpbSearchQueryReq) GetOp() []byte {
	if m != nil {
		return m.Op
	}
	return nil
}

func (m *RpbSearchQueryReq) GetFl() [][]byte {
	if m != nil {
		return m.Fl
	}
	return nil
}

func (m *RpbSearchQueryReq) GetPresort() []byte {
	if m != nil {
		return m.Presort
	}
	return nil
}

type RpbSearchQueryResp struct {
	Docs             []*RpbSearchDoc `protobuf:"bytes,1,rep,name=docs" json:"docs,omitempty"`
	MaxScore         *float32        `protobuf:"fixed32,2,opt,name=max_score" json:"max_score,omitempty"`
	NumFound         *uint32         `protobuf:"varint,3,opt,name=num_found" json:"num_found,omitempty"`
	XXX_unrecognized []byte          `json:"-"`
}

func (m *RpbSearchQueryResp) Reset()                    { *m = RpbSearchQueryResp{} }
func (m *RpbSearchQueryResp) String() string            { return proto.CompactTextString(m) }
func (*RpbSearchQueryResp) ProtoMessage()               {}
func (*RpbSearchQueryResp) Descriptor() ([]byte, []int) { return fileDescriptor0, []int{2} }

func (m *RpbSearchQueryResp) GetDocs() []*RpbSearchDoc {
	if m != nil {
		return m.Docs
	}
	return nil
}

func (m *RpbSearchQueryResp) GetMaxScore() float32 {
	if m != nil && m.MaxScore != nil {
		return *m.MaxScore
	}
	return 0
}

func (m *RpbSearchQueryResp) GetNumFound() uint32 {
	if m != nil && m.NumFound != nil {
		return *m.NumFound
	}
	return 0
}

func init() {
	proto.RegisterType((*RpbSearchDoc)(nil), "RpbSearchDoc")
	proto.RegisterType((*RpbSearchQueryReq)(nil), "RpbSearchQueryReq")
	proto.RegisterType((*RpbSearchQueryResp)(nil), "RpbSearchQueryResp")
}

func init() { proto.RegisterFile("riak_search.proto", fileDescriptor0) }

var fileDescriptor0 = []byte{
	// 268 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x09, 0x6e, 0x88, 0x02, 0xff, 0x5c, 0x50, 0xcb, 0x4e, 0x84, 0x30,
	0x14, 0x4d, 0x19, 0xe6, 0xc1, 0xb5, 0x68, 0xe8, 0xc6, 0x1b, 0xdd, 0x34, 0x6c, 0xec, 0x8a, 0x85,
	0x9f, 0x40, 0xfc, 0x80, 0x11, 0x17, 0x2e, 0x49, 0x81, 0x92, 0x21, 0x03, 0xb4, 0xd3, 0x42, 0x1c,
	0x3f, 0xc6, 0x7f, 0x35, 0x40, 0xd0, 0xe8, 0xee, 0x3c, 0x9a, 0xd3, 0x73, 0x2e, 0x44, 0xb6, 0x91,
	0xe7, 0xdc, 0x29, 0x69, 0xcb, 0x53, 0x62, 0xac, 0x1e, 0xf4, 0x03, 0x4c, 0xd2, 0x82, 0x63, 0x01,
	0x34, 0x33, 0xc5, 0xdb, 0x6c, 0xbf, 0xe8, 0x92, 0x21, 0xec, 0xea, 0x46, 0xb5, 0x95, 0x43, 0xc2,
	0x37, 0xe2, 0xe6, 0xf9, 0x90, 0x64, 0xa6, 0x38, 0xca, 0xc6, 0xc6, 0x5f, 0x04, 0xa2, 0x9f, 0xa7,
	0xaf, 0xa3, 0xb2, 0x9f, 0x99, 0xba, 0xb0, 0x00, 0xc8, 0x05, 0x09, 0xf7, 0x04, 0x65, 0x21, 0x6c,
	0x9b, 0xbe, 0x52, 0x57, 0xf4, 0x66, 0x4a, 0xc1, 0xb7, 0xfa, 0xc3, 0xe1, 0x86, 0x13, 0x11, 0x4e,
	0xa6, 0x1b, 0xa4, 0x1d, 0xd0, 0x9f, 0x29, 0x05, 0xdf, 0x69, 0x3b, 0xe0, 0x96, 0x13, 0x41, 0xd9,
	0xed, 0xf4, 0x69, 0x3b, 0x28, 0x8b, 0xbb, 0x99, 0x03, 0x78, 0x55, 0x8d, 0xfb, 0x15, 0x6b, 0x83,
	0x87, 0x15, 0xd7, 0x2d, 0x06, 0x7c, 0x23, 0x28, 0xbb, 0x83, 0xbd, 0xb1, 0x6a, 0x0e, 0x81, 0xc9,
	0x8c, 0xdf, 0x81, 0xfd, 0xaf, 0xe7, 0x0c, 0x7b, 0x04, 0xbf, 0xd2, 0xe5, 0xba, 0x26, 0x4c, 0xfe,
	0x8c, 0x8d, 0x20, 0xe8, 0xe4, 0x35, 0x77, 0xa5, 0xb6, 0x0a, 0x3d, 0x4e, 0x84, 0x37, 0x49, 0xfd,
	0xd8, 0xe5, 0xb5, 0x1e, 0xfb, 0x6a, 0xa9, 0x9e, 0x3e, 0xc1, 0x7d, 0xa9, 0xbb, 0xa4, 0x90, 0xee,
	0xa4, 0x93, 0xdf, 0xd3, 0x15, 0x63, 0x9d, 0xd2, 0xac, 0x91, 0xe7, 0x25, 0xef, 0x98, 0x7e, 0x07,
	0x00, 0x00, 0xff, 0xff, 0xf4, 0xd4, 0x3b, 0x37, 0x6b, 0x01, 0x00, 0x00,
}
